// TODO:
//   * Migrate all previous taiko test steps:
//     * OO: /welcome and /healthcheck
//     * Check passwords and calendar app
//   * Split Nextcloud and Onlyoffice tests


// https://www.npmjs.com/package/cypress-iframe
import 'cypress-iframe';


describe('Test nextcloud', () => {
  it('passes', () => {

    function clearModal(selector, timeout = 5000, attempts = 0) {
      const wait = 300
      for (let i = 1; i < timeout; i += wait) {
        cy.log('Waited ' + i + 'ms')
        cy.get('body')
          .then($body => {
            if ($body.find(selector).length) {
              cy.get('body').type('{esc}')
            }
          })
      cy.wait(wait)
      }
    }

    cy.visit('/')
    cy.log(Cypress.env('USE_SSO_LOGIN'))

    if (Cypress.env('USE_SSO_LOGIN') == true) {
      cy.contains('Log in with Stackspin').click()
      cy.url().should('include', 'dashboard')
      cy.get('#identifier.form-control')
        .type(Cypress.env('SSO_USER'))
      cy.get('#password.form-control')
        .type(Cypress.env('SSO_PW'))
      cy.contains('Go!').click()
    } else {
      cy.get('#user').type(Cypress.env('NEXTCLOUD_ADMIN_USER'))
      cy.get('#password').type(Cypress.env('NEXTCLOUD_ADMIN_PW')+'{enter}')
    }

    cy.contains('Recommended files')

    // Wait for eventual welcome modal and close it
    clearModal('#firstrunwizard')

    // Create a new OO document with a random file name
    cy.visit('apps/files')
    cy.get('.new').click()
    const file_rand = 'test-' + Math.random().toString(16).substr(2, 12)
    cy.get('[data-action=template-new-onlyoffice-1]').click().type(file_rand)
    cy.get('.icon-confirm').click()

    // Test Onlyoffice
    cy.frameLoaded('#onlyofficeFrame')
    cy.iframe('#onlyofficeFrame').within(() => {
      cy.frameLoaded('[name="frameEditor"]')
      cy.iframe('[name="frameEditor"]').within(() => {
        cy.get('#id-toolbar-btn-italic').should('be.visible').click({timeout: 60000})
        cy.get('#id_main').click().type('Hi from Cypress!')
      })
    })
  })
})
